// NeoPixel Ring simple sketch (c) 2013 Shae Erisson
// released under the GPLv3 license to match the rest of the AdaFruit NeoPixel library

#include <tinyNeoPixel.h>

#define LED_PIN 2
#define NPIXELS 1
#define BUTTON_PIN 3
#define NCOLORS   8

tinyNeoPixel pixel = tinyNeoPixel(NPIXELS, LED_PIN, NEO_RGB + NEO_KHZ800);

uint32_t colors [] = {
  0x00FF0000,
  0x0000FF00,
  0x000000FF,
  0x00FFFF00,
  0x00FF00FF,
  0x0000FFFF,
  0x00FFFFFF
};

uint8_t iColor = 0;
bool previousButtonState = HIGH;
int delayval = 500; // delay for half a second

void setup() {  
  pinMode(BUTTON_PIN, INPUT_PULLUP);
  pixel.begin();
  pixel.setBrightness(20);
  pixel.setPixelColor(0, colors[0]);
  
  pixel.show();  

  Serial.begin(115200);
}

void loop() {
  bool buttonState = digitalRead(BUTTON_PIN);
  if (previousButtonState == HIGH &&  buttonState == LOW) {
    delay(100);
    iColor = (iColor + 1) % NCOLORS;
    pixel.setPixelColor(0, colors[iColor]);
    pixel.show(); // This sends the updated pixel color to the hardware.
  }

  previousButtonState = buttonState;

  Serial.println((previousButtonState - buttonState) * 255);
  delay(10);

}
