#include <Wire.h>
#define PERIOD_EXAMPLE_VALUE    (0x01)
#define X0 (int32_t)1<<28
#define fastConstrain(a,b,c) (a < b) ? b : ((a >  c) ? c : a)

int32_t x = 0;
uint32_t x0 = 0;
int32_t v = 0;
int32_t a = 0;
int32_t m = 1;
int32_t c = 100 ;
int32_t k = 3;
volatile uint8_t speakerState = 0, timerTriggered = false;
uint8_t saw = 0;

inline void updateSpring() {
  a = (((x0 - x) / k) - (v / c));
  v += a;
  x += v;
}


void setup() {
  pinMode(0, OUTPUT);
  DACReference(INTERNAL4V34);

  takeOverTCA0();                           // This replaces disabling and resettng the timer, required previously.
  TCA0.SINGLE.CTRLB = (TCA_SINGLE_CMP0EN_bm | TCA_SINGLE_WGMODE_DSBOTTOM_gc); //Dual slope PWM mode OVF interrupt at BOTTOM, PWM on WO0
  TCA0.SINGLE.PER = 0x01C6; // Count all the way up to 0xFFFF
  // At 20MHz, this gives ~152Hz PWM
  TCA0.SINGLE.CMP0 = 128;
  TCA0.SINGLE.INTCTRL = TCA_SINGLE_OVF_bm; //enable overflow interrupt
  TCA0.SINGLE.CTRLA = TCA_SINGLE_ENABLE_bm; //enable the timer with no prescaler
}


ISR(TCA0_OVF_vect)
{
  //updateSpring();
  /* The interrupt flag has to be cleared manually */
  TCA0.SINGLE.INTFLAGS = TCA_SINGLE_OVF_bm;
  timerTriggered = true;
  x0 = saw >> 30;
}

uint8_t buttonState = HIGH, pButtonState = HIGH, analogOut = 0;

void loop() {
  updateSpring();
  analogOut = map(x, -1 << 28, 1 << 28, 0, 256);
  if (timerTriggered) {
    timerTriggered = false;
    analogWrite(0, analogOut);
  }

}
