#include <Adafruit_NeoPixel.h>

// Which pin on the Arduino is connected to the NeoPixels?
#define LED_PIN D3 // On Trinket or Gemma, suggest changing this to 1

#define BRIGHTNESS_R 50
#define BRIGHTNESS_G 50
#define BRIGHTNESS_B 50
#define FLASH_INTERVAL 75
#define NUMPIXELS 1 

Adafruit_NeoPixel pixels(NUMPIXELS, LED_PIN, NEO_GRB + NEO_KHZ800);

// Creates a unit32_t that represents whether the bit at <bitIndex> is high or low
uint32_t createDataColor(uint8_t dataByte, uint8_t bitIndex)
{
  return BRIGHTNESS_R << 16 | // Set the red (clock) channel to HIGH
         //determine wether the bit at <bitIndex> in <dataByte> is high
         BRIGHTNESS_B * ((dataByte & (1 << (7 - bitIndex))) > 0); 
}

uint8_t r, g, b, val;
uint8_t clockBit = 0;
uint8_t bitIndex = 0;
uint8_t dataByte = 0;
uint8_t sending = true;
uint32_t eMillis, cMillis, pMillis;
uint8_t byteIndex = 0;
uint8_t newByte = true;

void updatePixel(uint8_t *bytesToSend, uint8_t nBytes){
  cMillis = millis();
  eMillis += cMillis - pMillis;

  if (sending)
  {
    if (eMillis > FLASH_INTERVAL)
    {
      eMillis = 0;
      if (clockBit)
      {
        pixels.setPixelColor(0, createDataColor(bytesToSend[byteIndex] << 1, bitIndex));
        bitIndex++;
        if (bitIndex > 7)
        {
          bitIndex = 0;
          byteIndex++;
          if (byteIndex > nBytes)
          {
            byteIndex = 0;
          }
          newByte = true;
          bitIndex--;
        }
      }
      else
      {
        pixels.setPixelColor(0, 0);
      }
      clockBit = !clockBit;
    }
  }
  else
  {
    pixels.setPixelColor(0, pixels.Color(r, g, b));
  }

  if (newByte)
  {
    pixels.setPixelColor(0, pixels.Color(0, 100, 0));
    newByte = false;
    Serial.println(bytesToSend[byteIndex]);
  }

  pixels.show();
  pMillis = cMillis;

}
